/* to be placed in "samples/calc/TestCalc-oo.rex"; Object Rexx version

add the following line to "samples/calc/TestCalc.java" in
the static method where the extensionmap is defined:

    extensionmap.put("rex", "rexx");

---rgf, 2001-05-02 (on the way back home from the 12th Int'l Rexx Symposium
*/


/*********************************************************
 * A simple four function calculator, written in REXX    *
 *********************************************************/

/* *** create a res window                   */
res = .bsf~new("java.awt.TextField", "str", 0)


/* *** create a panel of buttons                */
panel = .bsf~new("java.awt.Panel")
panel~setLayout("obj", .bsf~new("java.awt.GridLayout", "i", 4, "i", 4))

buttons = "789*456/123-C0.+"
do i=1 to buttons~length
   label=buttons~substr(i, 1)
   button=.bsf~new("java.awt.Button", "str", label)
   panel~add("obj", button)

   if "*/-+"~pos(label)>0 then
      button~bsf.addEventListener("action", "", "call op '" ||label||"'")

   else if label="C" then
      button~bsf.addEventListener("action", "", "call clear")

   else
      button~bsf.addEventListener("action", "", "call press" label)
end


/* *** Place everything in the frame            */
frame = .bsf~lookupBean("frame")
frame~~setTitle("str", "Object Rexx Calc") ~~resize("i", 130, "i", 200)
frame~~add("str", "North", "o", res) ~~add("str", "Center", "o", panel)
frame~~validate ~~show
frame~bsf.addEventListener("window", "windowClosing", "call bsf 'exit'")

/* *** Initialize the state of the calculator   */
mem = 0
nextOp = "+"
autoClear = 1                   /* true         */

do forever      /* get eventText and execute it as a Rexx program       */
   interpret .bsf~pollEventText
end
exit


press:                          /* handle data entry keys       */
   parse arg key

   if autoClear  then
      res~setText("str", 0)

   if res~getText=="0" & key<>"." then
      res~setText("str", "")

   if key="." then
      if pos(".", res~getText)>0 then
         key=""

   res~setText("str", res~getText || key)

   autoClear=0                  /* set it to false              */
   return

/*  *** handle arithmetic keys  */
op:
   parse arg key
   num=res~getText
   if      nextOp="+" then mem=mem+num
   else if nextOp="-" then mem=mem-num
   else if nextOp="*" then mem=mem*num
   else if nextOp="/" & num<>0 then mem=mem/num
   nextOp=key
   res~setText("str", mem)
   autoClear=1          /* set to true          */
   return

/* handle the "C" key   */
clear:
   mem=0
   nextOp=""
   res~setText("str", 0)
   return

::requires "BSF.cls"    -- add Object Rexx proxy support
