/* to be placed in "samples/calc/TestCalc.rex";

add the following line to "samples/calc/TestCalc.java" in
the static method where the extensionmap is defined:

    extensionmap.put("rex", "rexx");

---rgf, 2001-05-02 (on the way back home from the 12th Int'l Rexx Symposium
*/


/*********************************************************
 * A simple four function calculator, written in REXX    *
 *********************************************************/

/* *** create a res window                   */
res = bsf("registerBean", "", "java.awt.TextField", "str", 0)

/* *** create a panel of buttons                */
panel = bsf("registerBean", "",  "java.awt.Panel")
call bsf "invoke", panel, "setLayout", "obj",,
         bsf("registerBean", "", "java.awt.GridLayout", "i", 4, "i", 4)

buttons = "789*456/123-C0.+"
do i=1 to length(buttons)
   label=substr(buttons, i, 1)
   button=bsf("registerBean", label, "java.awt.Button", "str", label)
   call bsf "invoke", panel, "add", "o", button
   if pos(label, "*/-+")>0 then
      call bsf "addEventListener", button, "action", "", "call op '" ||label||"'"
   else if label="C" then
      call bsf "addEventListener", button, "action", "", "call clear"
   else
      call bsf "addEventListener", button, "action", "", "call press" label
end


/* *** Place everything in the frame            */
frame = bsf("lookupBean", "frame")

call bsf "invoke", frame, "setTitle", "str", "Rexx Calc"
call bsf "invoke", frame, "resize", "i", 130, "i", 200
call bsf "invoke", frame, "add",    "str", "North", "o", res
call bsf "invoke", frame, "add",    "str", "Center", "o", panel
call bsf "invoke", frame, "validate"
call bsf "invoke", frame, "show"
call bsf "addEventListener", frame, "window", "windowClosing", "call bsf 'exit'"

/* *** Initialize the state of the calculator   */
mem = 0
nextOp = "+"
autoClear = 1   /* true                         */

do forever      /* get eventText and execute it as a Rexx program       */
   interpret bsf("pollEventText")
end
exit


press:                          /* handle data entry keys       */
   parse arg key

   if autoClear  then
      call bsf "invoke", res, "setText", "str", 0

   if bsf("invoke", res, "getText")=="0" & key<>"." then
      call bsf "invoke", res, "setText", "str", ""

   if key="." then
      if pos(".", bsf("invoke", res, "getText"))>0 then
         key=""


   call bsf "invoke", res, "setText", "str",,
        bsf("invoke", res, "getText") || key
   autoClear=0                  /* set it to false              */
   return

/*  *** handle arithmetic keys  */
op:
   parse arg key
   num=bsf("invoke", res, "getText")
   if      nextOp="+" then mem=mem+num
   else if nextOp="-" then mem=mem-num
   else if nextOp="*" then mem=mem*num
   else if nextOp="/" & num<>0 then mem=mem/num
   nextOp=key
   call bsf "invoke", res, "setText", "str", mem
   autoClear=1          /* set to true          */
   return

/* handle the "C" key   */
clear:
   mem=0
   nextOp=""
   call bsf "invoke", res, "setText", "str", 0
   return
